/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package databazevodnichzivocichu;

import java.io.*;

/**
 *
 * @author Dana Nejedlová <dana.nejedlova@tul.cz>
 */
public class Ryba extends VodniZivocich {

    private Snasenlivost snasenlivost;
    
    public Ryba(int pocetZivocichu, String soubor, String latinskyNazev, String zdroj, String cenaCZK, String snasenlivost) throws ChybnaDatovaVeta {
        super(pocetZivocichu, soubor, latinskyNazev, zdroj, cenaCZK);
        boolean snasenlivostIsValid = false;
        for (Snasenlivost s : Snasenlivost.values()) {
            if (s.getSnasenlivost().equals(snasenlivost)) {
                this.snasenlivost = s;
                snasenlivostIsValid = true;
                return;
            }
        }
        if (!snasenlivostIsValid) {
            throw new ChybnaDatovaVeta(pocetZivocichu, soubor, snasenlivost);
        }
    }

    public Snasenlivost getSnasenlivost() {
        return snasenlivost;
    }

    public void setSnasenlivost(Snasenlivost snasenlivost) {
        this.snasenlivost = snasenlivost;
    }

    @Override
    public String toString() {
        return super.toString() + ODDELOVAC_ATRIBUTU + snasenlivost.getSnasenlivost();
    }
    
    @Override
    public void zapisZivocicha(BufferedWriter zapisovaniDoSouboru) throws IOException {
        zapisovaniDoSouboru.write(toString());
    }
}
