/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package databazevodnichzivocichu;

import java.io.*;
import java.util.ArrayList;

/**
 *
 * @author Dana Nejedlová <dana.nejedlova@tul.cz>
 */
public abstract class SeznamVodniZivocich implements DataRecordAttributes {

    public final String ODDELOVAC_NAZVU_A_PRIPONY_SOUBORU = ".";
    public final String PRIPONA_SOUBORU = "txt";
    private String soubor;
    private int pocetAtributu;
    public ArrayList<VodniZivocich> vodniZivocich;

    public String getSoubor() {
        return soubor;
    }

    public void setSoubor(String fileName) {
        soubor = fileName;
    }

    public int getPocetAtributu() {
        return pocetAtributu;
    }

    public void setPocetAtributu(int pocetAtributuZivocicha) {
        pocetAtributu = pocetAtributuZivocicha;
    }

    public abstract void vytvorZivocicha(int pocetZivocichu, String soubor, String[] dataRadku) throws ChybnaDatovaVeta; // Každý potomek může mít odlišný počet atributů.

    public void vypisSeznamu() {
        for (int i = 0; i < vodniZivocich.size(); i++) {
            System.out.println(vodniZivocich.get(i));
        }
    }

    public void nactiSoubor() {
        String radek;
        String[] dataRadku;
        BufferedReader cteniZeSouboru;
        try {
            cteniZeSouboru = new BufferedReader(new FileReader(soubor));
            while ((radek = cteniZeSouboru.readLine()) != null) {
                dataRadku = radek.split(ODDELOVAC_ATRIBUTU);
                if (dataRadku.length == pocetAtributu) {
                    vytvorZivocicha(vodniZivocich.size() + 1, soubor, dataRadku);
                } else {
                    throw new ChybnaDatovaVeta(vodniZivocich.size() + 1, soubor, dataRadku.length, pocetAtributu);
                }
            }
        } catch (ChybnaDatovaVeta e) {
            System.out.println(e.getMessage());
        } catch (IOException e) {
            System.out.println("Nebyl nalezen soubor \"" + soubor + "\".");
        }
    }

    public void zapisDoSouboru(String souborVystupni) {
        try {
            BufferedWriter zapisovaniDoSouboru = new BufferedWriter(new FileWriter(souborVystupni));
            for (int i = 0; i < vodniZivocich.size(); i++) {
                vodniZivocich.get(i).zapisZivocicha(zapisovaniDoSouboru);
                zapisovaniDoSouboru.newLine();
            }
            zapisovaniDoSouboru.close();
        } catch (IOException e) {
            System.out.println("Zápis do souboru \"" + souborVystupni + "\" se nepovedl.");
        }
    }
}
