/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package databazevodnichzivocichu;

import java.io.*;
import java.net.*;

/**
 *
 * @author Dana Nejedlová <dana.nejedlova@tul.cz>
 */
public abstract class VodniZivocich implements DataRecordAttributes {

    private String latinskyNazev;
    private URL zdroj;
    private int cenaCZK;

    public VodniZivocich(int pocetZivocichu, String soubor, String latinskyNazev, String zdroj, String cenaCZK) {
        this.latinskyNazev = latinskyNazev;
        try {
            this.zdroj = new URL(zdroj);
            this.cenaCZK = Integer.valueOf(cenaCZK);
        } catch (MalformedURLException e) {
            System.out.println("Chybné URL \"" + zdroj + "\" na řádku " + pocetZivocichu + " v souboru \"" + soubor + "\".");
        } catch (NumberFormatException e) {
            System.out.println("Chybná cena \"" + cenaCZK + "\" na řádku " + pocetZivocichu + " v souboru \"" + soubor + "\".");
        }
    }

    public abstract void zapisZivocicha(BufferedWriter zapisovaniDoSouboru) throws IOException;

    @Override
    public String toString() {
        return latinskyNazev + ODDELOVAC_ATRIBUTU + zdroj + ODDELOVAC_ATRIBUTU + cenaCZK;
    }

    public String getLatinskyNazev() {
        return latinskyNazev;
    }

    public URL getZdroj() {
        return zdroj;
    }

    public int getCenaCZK() {
        return cenaCZK;
    }

    public void setLatinskyNazev(String latinskyNazev) {
        this.latinskyNazev = latinskyNazev;
    }

    public void setZdroj(URL zdroj) {
        this.zdroj = zdroj;
    }

    public void setCenaCZK(int cenaCZK) {
        this.cenaCZK = cenaCZK;
    }
}
